From 4cecdfa87dae8e84589b82faaf93705160eb4856 Mon Sep 17 00:00:00 2001
From: Anton Obzhirov & Julien Isorce <a.obzhirov+j.isorce@samsung.com>
Date: Wed, 24 Jun 2015 19:10:05 +0100
Subject: [PATCH] Add GStreamer backend for media playback in Chromium.

- Media Process
- GstGL
- GstPlayer

Doc: https://github.com/Samsung/ChromiumGStreamerBackend/

Signed-off-by: Anton Obzhirov <a.obzhirov@samsung.com>
Signed-off-by: Julien Isorce <j.isorce@samsung.com>

Updated version (104 followup commits) backported to Chromium 45 and squashed
into one commit by Kevin Kofler <Kevin@tigcc.ticalc.org>.
---
 README.md                                          |  397 +++++++
 base/message_loop/message_pump_glib.cc             |   11 +
 base/threading/thread_restrictions.h               |    6 +
 build/common.gypi                                  |    9 +
 build/gn_migration.gypi                            |    2 +-
 build/install-build-deps.sh                        |   17 +
 build/linux/system.gyp                             |   27 +
 chrome/app/chrome_crash_reporter_client.cc         |    5 +
 chrome/app/chrome_main_delegate.cc                 |    6 +
 chrome/app/generated_resources.grd                 |   10 +-
 chrome/browser/about_flags.cc                      |    7 +
 chrome/browser/chrome_content_browser_client.cc    |    9 +
 .../providers/child_process_task.cc                |    5 +
 .../child_process_resource_provider.cc             |    5 +
 chrome/utility/extensions/extensions_handler.cc    |    4 +
 .../media_galleries/media_metadata_parser.cc       |    5 +
 content/app/content_main_runner.cc                 |   22 +
 content/browser/browser_main_loop.cc               |   26 +
 content/browser/browser_main_loop.h                |    3 +
 .../browser/gpu/gpu_data_manager_impl_private.cc   |    9 +
 .../loader/resource_dispatcher_host_impl.cc        |    1 +
 content/browser/media/media_data_manager_impl.cc   |   78 ++
 content/browser/media/media_data_manager_impl.h    |   96 ++
 .../media/media_data_manager_impl_private.cc       |  118 ++
 .../media/media_data_manager_impl_private.h        |   83 ++
 content/browser/media/media_process_host.cc        |  583 +++++++++
 content/browser/media/media_process_host.h         |  179 +++
 .../browser/media/media_process_host_ui_shim.cc    |  166 +++
 content/browser/media/media_process_host_ui_shim.h |   84 ++
 .../browser/renderer_host/media_message_filter.cc  |   76 ++
 .../browser/renderer_host/media_message_filter.h   |   58 +
 .../renderer_host/render_process_host_impl.cc      |   17 +
 .../renderer_host/render_process_host_impl.h       |    8 +
 content/common/child_process_host_impl.cc          |   17 +
 content/common/content_constants_internal.cc       |    3 +
 content/common/content_constants_internal.h        |    3 +
 content/common/content_message_generator.h         |    5 +
 .../common/gpu/client/command_buffer_metrics.cc    |   10 +
 content/common/gpu/client/command_buffer_metrics.h |    3 +
 .../common/gpu/client/command_buffer_proxy_impl.cc |   39 +
 .../common/gpu/client/command_buffer_proxy_impl.h  |    8 +
 content/common/gpu/gpu_channel.cc                  |   32 +
 content/common/gpu/gpu_channel.h                   |    7 +
 content/common/gpu/gpu_command_buffer_stub.cc      |   63 +
 content/common/gpu/gpu_command_buffer_stub.h       |   10 +
 content/common/gpu/gpu_messages.h                  |    8 +
 content/common/gpu/gpu_process_launch_causes.h     |    3 +
 content/common/media/media_channel.cc              |  369 ++++++
 content/common/media/media_channel.h               |  154 +++
 content/common/media/media_channel_filter.cc       |   97 ++
 content/common/media/media_channel_filter.h        |   99 ++
 content/common/media/media_channel_host.cc         |  151 +++
 content/common/media/media_channel_host.h          |  129 ++
 content/common/media/media_config.h                |   12 +
 content/common/media/media_messages.h              |   83 ++
 .../media/media_player_messages_enums_gstreamer.h  |   15 +
 .../common/media/media_player_messages_gstreamer.h |  176 +++
 content/common/media/media_process_launch_causes.h |   23 +
 content/common/sandbox_init_mac.cc                 |    6 +
 .../common/sandbox_linux/bpf_media_policy_linux.cc |  535 +++++++++
 .../common/sandbox_linux/bpf_media_policy_linux.h  |   64 +
 content/common/sandbox_linux/sandbox_linux.cc      |    1 +
 .../sandbox_linux/sandbox_seccomp_bpf_linux.cc     |   15 +
 content/content.gyp                                |   21 +
 content/content_browser.gypi                       |   16 +
 content/content_common.gypi                        |   33 +
 content/content_media.gypi                         |   44 +
 content/content_renderer.gypi                      |   43 +
 content/media/gstreamer/gpuprocess/client_egl.cc   |  162 +++
 content/media/gstreamer/gpuprocess/client_egl.h    |   30 +
 .../gpuprocess/gstglcontext_gpu_process.c          |  147 +++
 .../gpuprocess/gstglcontext_gpu_process.h          |   74 ++
 .../gpuprocess/gstgldisplay_gpu_process.c          |   44 +
 .../gpuprocess/gstgldisplay_gpu_process.h          |   52 +
 .../gstreamer/gpuprocess/gstglwindow_gpu_process.c |   48 +
 .../gstreamer/gpuprocess/gstglwindow_gpu_process.h |   75 ++
 content/media/gstreamer/gst_chromium_aes_ctr.cc    |   77 ++
 content/media/gstreamer/gst_chromium_aes_ctr.h     |   24 +
 .../gst_chromium_common_encryption_decryptor.cc    |  469 ++++++++
 .../gst_chromium_common_encryption_decryptor.h     |   39 +
 .../media/gstreamer/gst_chromium_http_source.cc    |  903 ++++++++++++++
 content/media/gstreamer/gst_chromium_http_source.h |   85 ++
 content/media/gstreamer/gst_chromium_media_src.cc  |  621 ++++++++++
 content/media/gstreamer/gst_chromium_media_src.h   |   82 ++
 content/media/gstreamer/media_player_gstreamer.cc  |  802 +++++++++++++
 content/media/gstreamer/media_player_gstreamer.h   |  190 +++
 content/media/in_process_media_thread.cc           |   39 +
 content/media/in_process_media_thread.h            |   42 +
 content/media/media_child_thread.cc                |  330 ++++++
 content/media/media_child_thread.h                 |  137 +++
 content/media/media_main.cc                        |  167 +++
 content/media/media_process.cc                     |   13 +
 content/media/media_process.h                      |   22 +
 content/public/browser/media_data_manager.h        |   43 +
 .../public/browser/media_data_manager_observer.h   |   26 +
 content/public/common/content_switches.cc          |   21 +
 content/public/common/content_switches.h           |    9 +
 content/public/common/process_type.h               |    3 +
 content/public/common/sandbox_type.h               |    5 +
 content/renderer/media/audio_decoder.cc            |    4 +
 .../media/gstreamer/webmediaplayer_gstreamer.cc    | 1245 ++++++++++++++++++++
 .../media/gstreamer/webmediaplayer_gstreamer.h     |  390 ++++++
 .../media/gstreamer/webmediasource_gstreamer.cc    |  128 ++
 .../media/gstreamer/webmediasource_gstreamer.h     |   68 ++
 .../media/gstreamer/websourcebuffer_gstreamer.cc   |  164 +++
 .../media/gstreamer/websourcebuffer_gstreamer.h    |   67 ++
 content/renderer/pepper/video_decoder_shim.cc      |    6 +
 content/renderer/render_frame_impl.cc              |   33 +
 content/renderer/render_thread_impl.cc             |   52 +-
 content/renderer/render_thread_impl.h              |   19 +-
 content/shell/app/shell_crash_reporter_client.cc   |    5 +
 .../shell/browser/shell_content_browser_client.cc  |    9 +
 gpu/command_buffer/service/feature_info.cc         |   14 +
 gpu/config/gpu_blacklist.cc                        |    3 +
 images/chromium_gstreamer_backend.odp              |  Bin 0 -> 638416 bytes
 images/chromium_gstreamer_backend.pdf              |  Bin 0 -> 448581 bytes
 images/chromium_media_process_eme.png              |  Bin 0 -> 32666 bytes
 images/chromium_media_process_ipc.png              |  Bin 0 -> 27372 bytes
 images/chromium_media_process_mse.png              |  Bin 0 -> 29608 bytes
 images/chromium_media_process_overview.png         |  Bin 0 -> 168242 bytes
 images/chromium_media_process_sandbox.png          |  Bin 0 -> 17335 bytes
 images/chromium_media_process_stack.png            |  Bin 0 -> 40486 bytes
 images/chromium_media_process_zero_copy.png        |  Bin 0 -> 57624 bytes
 images/talk_at_gstreamer_conference_2015.jpg       |  Bin 0 -> 26628 bytes
 ipc/ipc_message_start.h                            |    3 +
 media/base/cdm_key_information.h                   |    3 +
 media/base/media_switches.cc                       |   14 +
 media/base/media_switches.h                        |    5 +
 media/base/mime_util.cc                            |    2 +-
 media/blink/buffered_data_source.cc                |   27 +-
 media/blink/buffered_data_source.h                 |   20 +
 media/blink/buffered_resource_loader.cc            |   47 +-
 media/blink/buffered_resource_loader.h             |   14 +-
 media/blink/encrypted_media_player_support.cc      |   16 +
 media/blink/encrypted_media_player_support.h       |   21 +-
 media/blink/webmediaplayer_impl.cc                 |    4 +
 media/cdm/aes_decryptor.cc                         |    6 +-
 media/cdm/cenc_utils.cc                            |   20 +
 media/cdm/proxy_decryptor.cc                       |   28 +-
 media/cdm/proxy_decryptor.h                        |   26 +
 .../linux/syscall_broker/broker_file_permission.cc |    2 +-
 .../linux/syscall_broker/broker_file_permission.h  |   13 +-
 sandbox/linux/syscall_broker/broker_host.cc        |   10 +
 ui/gl/gl_image_egl.cc                              |   13 +
 ui/gl/gl_image_egl.h                               |   15 +
 ui/gl/gl_surface_egl.cc                            |    5 +
 ui/gl/gl_surface_x11.cc                            |    3 +
 147 files changed, 11711 insertions(+), 23 deletions(-)
 create mode 100644 README.md
 create mode 100644 content/browser/media/media_data_manager_impl.cc
 create mode 100644 content/browser/media/media_data_manager_impl.h
 create mode 100644 content/browser/media/media_data_manager_impl_private.cc
 create mode 100644 content/browser/media/media_data_manager_impl_private.h
 create mode 100644 content/browser/media/media_process_host.cc
 create mode 100644 content/browser/media/media_process_host.h
 create mode 100644 content/browser/media/media_process_host_ui_shim.cc
 create mode 100644 content/browser/media/media_process_host_ui_shim.h
 create mode 100644 content/browser/renderer_host/media_message_filter.cc
 create mode 100644 content/browser/renderer_host/media_message_filter.h
 create mode 100644 content/common/media/media_channel.cc
 create mode 100644 content/common/media/media_channel.h
 create mode 100644 content/common/media/media_channel_filter.cc
 create mode 100644 content/common/media/media_channel_filter.h
 create mode 100644 content/common/media/media_channel_host.cc
 create mode 100644 content/common/media/media_channel_host.h
 create mode 100644 content/common/media/media_config.h
 create mode 100644 content/common/media/media_messages.h
 create mode 100644 content/common/media/media_player_messages_enums_gstreamer.h
 create mode 100644 content/common/media/media_player_messages_gstreamer.h
 create mode 100644 content/common/media/media_process_launch_causes.h
 create mode 100644 content/common/sandbox_linux/bpf_media_policy_linux.cc
 create mode 100644 content/common/sandbox_linux/bpf_media_policy_linux.h
 create mode 100644 content/content_media.gypi
 create mode 100644 content/media/gstreamer/gpuprocess/client_egl.cc
 create mode 100644 content/media/gstreamer/gpuprocess/client_egl.h
 create mode 100644 content/media/gstreamer/gpuprocess/gstglcontext_gpu_process.c
 create mode 100644 content/media/gstreamer/gpuprocess/gstglcontext_gpu_process.h
 create mode 100644 content/media/gstreamer/gpuprocess/gstgldisplay_gpu_process.c
 create mode 100644 content/media/gstreamer/gpuprocess/gstgldisplay_gpu_process.h
 create mode 100644 content/media/gstreamer/gpuprocess/gstglwindow_gpu_process.c
 create mode 100644 content/media/gstreamer/gpuprocess/gstglwindow_gpu_process.h
 create mode 100644 content/media/gstreamer/gst_chromium_aes_ctr.cc
 create mode 100644 content/media/gstreamer/gst_chromium_aes_ctr.h
 create mode 100644 content/media/gstreamer/gst_chromium_common_encryption_decryptor.cc
 create mode 100644 content/media/gstreamer/gst_chromium_common_encryption_decryptor.h
 create mode 100644 content/media/gstreamer/gst_chromium_http_source.cc
 create mode 100644 content/media/gstreamer/gst_chromium_http_source.h
 create mode 100644 content/media/gstreamer/gst_chromium_media_src.cc
 create mode 100644 content/media/gstreamer/gst_chromium_media_src.h
 create mode 100644 content/media/gstreamer/media_player_gstreamer.cc
 create mode 100644 content/media/gstreamer/media_player_gstreamer.h
 create mode 100644 content/media/in_process_media_thread.cc
 create mode 100644 content/media/in_process_media_thread.h
 create mode 100644 content/media/media_child_thread.cc
 create mode 100644 content/media/media_child_thread.h
 create mode 100644 content/media/media_main.cc
 create mode 100644 content/media/media_process.cc
 create mode 100644 content/media/media_process.h
 create mode 100644 content/public/browser/media_data_manager.h
 create mode 100644 content/public/browser/media_data_manager_observer.h
 create mode 100644 content/renderer/media/gstreamer/webmediaplayer_gstreamer.cc
 create mode 100644 content/renderer/media/gstreamer/webmediaplayer_gstreamer.h
 create mode 100644 content/renderer/media/gstreamer/webmediasource_gstreamer.cc
 create mode 100644 content/renderer/media/gstreamer/webmediasource_gstreamer.h
 create mode 100644 content/renderer/media/gstreamer/websourcebuffer_gstreamer.cc
 create mode 100644 content/renderer/media/gstreamer/websourcebuffer_gstreamer.h
 create mode 100644 images/chromium_gstreamer_backend.odp
 create mode 100644 images/chromium_gstreamer_backend.pdf
 create mode 100644 images/chromium_media_process_eme.png
 create mode 100644 images/chromium_media_process_ipc.png
 create mode 100644 images/chromium_media_process_mse.png
 create mode 100644 images/chromium_media_process_overview.png
 create mode 100644 images/chromium_media_process_sandbox.png
 create mode 100644 images/chromium_media_process_stack.png
 create mode 100644 images/chromium_media_process_zero_copy.png
 create mode 100644 images/talk_at_gstreamer_conference_2015.jpg

diff --git a/base/message_loop/message_pump_glib.cc b/base/message_loop/message_pump_glib.cc
index f06f60d..37a0101 100644
--- a/base/message_loop/message_pump_glib.cc
+++ b/base/message_loop/message_pump_glib.cc
@@ -142,6 +142,11 @@ ThreadInfo* thread_info = NULL;
 
 void CheckThread(MessagePumpGlib* pump) {
   AutoLock auto_lock(thread_info_lock.Get());
+#if defined(USE_GSTREAMER)
+  if (thread_info && thread_info->pump != pump) {
+     return;
+  }
+#endif
   if (!thread_info) {
     thread_info = new ThreadInfo;
     thread_info->pump = pump;
@@ -181,7 +186,13 @@ struct MessagePumpGlib::RunState {
 
 MessagePumpGlib::MessagePumpGlib()
     : state_(NULL),
+#if defined(USE_GSTREAMER)
+      context_(g_main_context_get_thread_default()
+                   ? g_main_context_get_thread_default()
+                   : g_main_context_default()),
+#else
       context_(g_main_context_default()),
+#endif
       wakeup_gpollfd_(new GPollFD) {
   // Create our wakeup pipe, which is used to flag when work was scheduled.
   int fds[2];
diff --git a/base/threading/thread_restrictions.h b/base/threading/thread_restrictions.h
index b6cfa72..c5125d1 100644
--- a/base/threading/thread_restrictions.h
+++ b/base/threading/thread_restrictions.h
@@ -39,6 +39,9 @@ class BrowserGpuMemoryBufferManager;
 class BrowserShutdownProfileDumper;
 class BrowserTestBase;
 class GpuChannelHost;
+#if defined(USE_GSTREAMER)
+class MediaChannelHost;
+#endif
 class NestedMessagePumpAndroid;
 class RenderWidgetResizeHelper;
 class ScopedAllowWaitForAndroidLayoutTests;
@@ -202,6 +205,9 @@ class BASE_EXPORT ThreadRestrictions {
   friend class
       content::BrowserGpuMemoryBufferManager;     // http://crbug.com/420368
   friend class content::GpuChannelHost;           // http://crbug.com/125264
+#if defined(USE_GSTREAMER)
+  friend class content::MediaChannelHost;
+#endif
   friend class content::TextInputClientMac;       // http://crbug.com/121917
   friend class dbus::Bus;                         // http://crbug.com/125222
   friend class disk_cache::BackendImpl;           // http://crbug.com/74623
diff --git a/build/common.gypi b/build/common.gypi
index 7456795..8a0ee32 100644
--- a/build/common.gypi
+++ b/build/common.gypi
@@ -123,8 +123,11 @@
             # Whether we're a traditional desktop unix.
             ['(OS=="linux" or OS=="freebsd" or OS=="openbsd" or OS=="solaris") and chromeos==0', {
               'desktop_linux%': 1,
+              'use_gstreamer%': 1,
+              'use_sysroot%': 0,
             }, {
               'desktop_linux%': 0,
+              'use_gstreamer%': 0,
             }],
 
             # Embedded implies ozone.
@@ -148,6 +151,7 @@
         'use_aura%': '<(use_aura)',
         'use_ash%': '<(use_ash)',
         'use_cras%': '<(use_cras)',
+        'use_gstreamer%': '<(use_gstreamer)',
         'use_ozone%': '<(use_ozone)',
         'embedded%': '<(embedded)',
         'use_libpci%': '<(use_libpci)',
@@ -323,6 +327,7 @@
       'use_aura%': '<(use_aura)',
       'use_ash%': '<(use_ash)',
       'use_cras%': '<(use_cras)',
+      'use_gstreamer%': '<(use_gstreamer)',
       'use_libpci%': '<(use_libpci)',
       'use_ozone%': '<(use_ozone)',
       'use_ozone_evdev%': '<(use_ozone_evdev)',
@@ -1107,6 +1112,7 @@
     'use_glib%': '<(use_glib)',
     'use_pango%': '<(use_pango)',
     'use_cairo%': '<(use_cairo)',
+    'use_gstreamer%': '<(use_gstreamer)',
     'use_ozone%': '<(use_ozone)',
     'use_ozone_evdev%': '<(use_ozone_evdev)',
     'use_xkbcommon%': '<(use_xkbcommon)',
@@ -2677,6 +2683,9 @@
       ['use_cairo==1', {
         'defines': ['USE_CAIRO=1'],
       }],
+      ['use_gstreamer==1', {
+        'defines': ['USE_GSTREAMER=1'],
+      }],
       ['use_cras==1', {
         'defines': ['USE_CRAS=1'],
       }],
diff --git a/build/gn_migration.gypi b/build/gn_migration.gypi
index 0323765..c8996d9 100644
--- a/build/gn_migration.gypi
+++ b/build/gn_migration.gypi
@@ -98,7 +98,7 @@
         '../ipc/ipc.gyp:ipc_tests',
         '../ipc/mojo/ipc_mojo.gyp:ipc_mojo_unittests',
         '../jingle/jingle.gyp:jingle_unittests',
-        '../media/media.gyp:ffmpeg_regression_tests',  # TODO(GYP) this should be conditional on media_use_ffmpeg
+        #'../media/media.gyp:ffmpeg_regression_tests',  # TODO(GYP) this should be conditional on media_use_ffmpeg
         '../media/media.gyp:media_perftests',
         '../media/media.gyp:media_unittests',
         '../media/midi/midi.gyp:midi_unittests',
diff --git a/build/install-build-deps.sh b/build/install-build-deps.sh
index 0c39d87..4ce3b83 100755
--- a/build/install-build-deps.sh
+++ b/build/install-build-deps.sh
@@ -40,6 +40,8 @@ package_exists() {
 do_inst_arm=1
 do_inst_nacl=1
 
+do_inst_gstreamer=1
+
 while test "$1" != ""
 do
   case "$1" in
@@ -52,6 +54,7 @@ do
   --no-chromeos-fonts)      do_inst_chromeos_fonts=0;;
   --nacl)                   do_inst_nacl=1;;
   --no-nacl)                do_inst_nacl=0;;
+  --gstreamer)              do_inst_gstreamer=1;;
   --no-prompt)              do_default=1
                             do_quietly="-qq --assume-yes"
     ;;
@@ -319,6 +322,20 @@ else
   nacl_list=
 fi
 
+if test "$do_inst_gstreamer" = "1"; then
+  echo "Including GStreamer."
+  lib_list="${lib_list} libgstreamer1.0-0 libgstreamer-plugins-base1.0-0
+           libgstreamer-plugins-good1.0-0 libgstreamer-plugins-bad1.0-0
+           gstreamer1.0-plugins-ugly gstreamer1.0-libav"
+
+  dev_list="${dev_list} libgstreamer1.0-dev libgstreamer-plugins-base1.0-dev
+           libgstreamer-plugins-bad1.0-dev"
+
+  dbg_list="${dbg_list} libgstreamer1.0-0-dbg gstreamer1.0-plugins-base-dbg
+           gstreamer1.0-plugins-good-dbg gstreamer1.0-plugins-bad-dbg
+           gstreamer1.0-libav-dbg"
+fi
+
 # The `sort -r -s -t: -k2` sorts all the :i386 packages to the front, to avoid
 # confusing dpkg-query (crbug.com/446172).
 packages="$(
diff --git a/build/linux/system.gyp b/build/linux/system.gyp
index a1d6bf0..c33850c 100644
--- a/build/linux/system.gyp
+++ b/build/linux/system.gyp
@@ -1218,5 +1218,32 @@
         }],
       ],
     },
+    {
+      'target_name': 'gstreamer',
+      'type': 'none',
+      'variables': {
+        'gstreamer_packages': 'gstreamer-1.0 gstreamer-base-1.0 gstreamer-audio-1.0 gstreamer-video-1.0 gstreamer-app-1.0 gstreamer-gl-1.0 gstreamer-player-1.0',
+      },
+      'conditions': [
+        ['use_gstreamer==1', {
+          'all_dependent_settings': {
+            'cflags': [
+              '<!@(<(pkg-config) --cflags <(gstreamer_packages))',
+            ],
+            'defines': [
+              'GST_USE_UNSTABLE_API',
+            ],
+          },
+          'link_settings': {
+            'ldflags': [
+              '<!@(<(pkg-config) --libs-only-L --libs-only-other <(gstreamer_packages))',
+            ],
+            'libraries': [
+              '<!@(<(pkg-config) --libs-only-l <(gstreamer_packages))',
+            ],
+          },
+        }],
+      ],
+    },
   ],
 }
diff --git a/chrome/app/chrome_crash_reporter_client.cc b/chrome/app/chrome_crash_reporter_client.cc
index a5474cd..aa90800 100644
--- a/chrome/app/chrome_crash_reporter_client.cc
+++ b/chrome/app/chrome_crash_reporter_client.cc
@@ -351,7 +351,12 @@ bool ChromeCrashReporterClient::EnableBreakpadForProcess(
          process_type == switches::kPluginProcess ||
          process_type == switches::kPpapiPluginProcess ||
          process_type == switches::kZygoteProcess ||
+#if defined(USE_GSTREAMER)
+         process_type == switches::kGpuProcess ||
+         process_type == switches::kMediaProcess;
+#else
          process_type == switches::kGpuProcess;
+#endif
 }
 
 }  // namespace chrome
diff --git a/chrome/app/chrome_main_delegate.cc b/chrome/app/chrome_main_delegate.cc
index 5189e6b..9992198 100644
--- a/chrome/app/chrome_main_delegate.cc
+++ b/chrome/app/chrome_main_delegate.cc
@@ -214,6 +214,9 @@ static void AdjustLinuxOOMScore(const std::string& process_type) {
     score = kPluginScore + kScoreBump;
   } else if (process_type == switches::kUtilityProcess ||
              process_type == switches::kGpuProcess ||
+#if defined(USE_GSTREAMER)
+             process_type == switches::kMediaProcess ||
+#endif
              process_type == switches::kServiceProcess) {
     score = kMiscScore;
 #ifndef DISABLE_NACL
@@ -727,6 +730,9 @@ void ChromeMainDelegate::PreSandboxStartup() {
     DCHECK(command_line.HasSwitch(switches::kLang) ||
            process_type == switches::kZygoteProcess ||
            process_type == switches::kGpuProcess ||
+#if defined(USE_GSTREAMER)
+           process_type == switches::kMediaProcess ||
+#endif
            process_type == switches::kNaClLoaderProcess ||
            process_type == switches::kPpapiBrokerProcess ||
            process_type == switches::kPpapiPluginProcess);
diff --git a/chrome/app/generated_resources.grd b/chrome/app/generated_resources.grd
index 8983f04..24eefa1 100644
--- a/chrome/app/generated_resources.grd
+++ b/chrome/app/generated_resources.grd
@@ -4397,7 +4397,7 @@ Even if you have downloaded files from this website before, the website might ha
       </message>
 
       <message name="IDS_EXTENSION_PERMISSION_LINE" desc="Template for item in list of privileges that an extension or app has">
-          • <ph name="PERMISSION">$1<ex>Read and change all your data on the websites you visit</ex></ph>
+          • <ph name="PERMISSION">$1<ex>Read and change all your data on the websites you visit</ex></ph>
       </message>
       <message name="IDS_EXTENSION_RATING_COUNT" desc="Number of ratings an app or extensions has (displayed after star icons)">
         (<ph name="RATING_COUNT">$1<ex>46</ex></ph>)
@@ -5778,6 +5778,14 @@ Keep your key file in a safe place. You will need it to create new versions of y
       <message name="IDS_FLAGS_DEBUG_SHORTCUTS_NAME" desc="Name of the 'Debugging keyboard shortcuts' lab.">
         Debugging keyboard shortcuts
       </message>
+      <!-- <if expr="use_gstreamer">  -->
+        <message name="IDS_FLAGS_ENABLE_GSTREAMER_MEDIA_BACKEND_NAME" desc="Name of the 'Enable GStreamer media backend' lab.">
+          Enable GStreamer media backend
+        </message>
+        <message name="IDS_FLAGS_ENABLE_GSTREAMER_MEDIA_BACKEND_DESCRIPTION" desc="Description of the 'Enable GStreamer media backend' lab.">
+          Enable the use of GStreamer as media backend for video playback.
+        </message>
+      <!-- </if> -->
       <message name="IDS_FLAGS_IGNORE_GPU_BLACKLIST_NAME" desc="Name of the 'Ignore GPU blacklist' lab.">
         Override software rendering list
       </message>
diff --git a/chrome/browser/about_flags.cc b/chrome/browser/about_flags.cc
index a25e2ba..23151db 100644
--- a/chrome/browser/about_flags.cc
+++ b/chrome/browser/about_flags.cc
@@ -566,6 +566,13 @@ const Experiment::Choice kV8CacheOptionsChoices[] = {
 //
 // When adding a new choice, add it to the end of the list.
 const Experiment kExperiments[] = {
+#if defined(USE_GSTREAMER)
+    {"enable-gstreamer-media-backend",
+     IDS_FLAGS_ENABLE_GSTREAMER_MEDIA_BACKEND_NAME,
+     IDS_FLAGS_ENABLE_GSTREAMER_MEDIA_BACKEND_DESCRIPTION,
+     kOsLinux,
+     SINGLE_VALUE_TYPE(switches::kEnableGStreamerMediaBackend)},
+#endif
     {"ignore-gpu-blacklist",
      IDS_FLAGS_IGNORE_GPU_BLACKLIST_NAME,
      IDS_FLAGS_IGNORE_GPU_BLACKLIST_DESCRIPTION,
diff --git a/chrome/browser/chrome_content_browser_client.cc b/chrome/browser/chrome_content_browser_client.cc
index 44869b2..9eb5b8e 100644
--- a/chrome/browser/chrome_content_browser_client.cc
+++ b/chrome/browser/chrome_content_browser_client.cc
@@ -497,6 +497,15 @@ int GetCrashSignalFD(const base::CommandLine& command_line) {
     return crash_handler->GetDeathSignalSocket();
   }
 
+#if defined(USE_GSTREAMER)
+  if (process_type == switches::kMediaProcess) {
+    static breakpad::CrashHandlerHostLinux* crash_handler = NULL;
+    if (!crash_handler)
+      crash_handler = CreateCrashHandlerHost(process_type);
+    return crash_handler->GetDeathSignalSocket();
+  }
+#endif
+
   return -1;
 }
 #endif  // defined(OS_POSIX) && !defined(OS_ANDROID) && !defined(OS_MACOSX)
diff --git a/chrome/browser/task_management/providers/child_process_task.cc b/chrome/browser/task_management/providers/child_process_task.cc
index 9770adc..d628449 100644
--- a/chrome/browser/task_management/providers/child_process_task.cc
+++ b/chrome/browser/task_management/providers/child_process_task.cc
@@ -56,6 +56,11 @@ base::string16 GetLocalizedTitle(const base::string16& title,
       return l10n_util::GetStringUTF16(IDS_TASK_MANAGER_UTILITY_PREFIX);
     case content::PROCESS_TYPE_GPU:
       return l10n_util::GetStringUTF16(IDS_TASK_MANAGER_GPU_PREFIX);
+#if defined(USE_GSTREAMER)
+    // TODO: add localized resource
+    case content::PROCESS_TYPE_MEDIA:
+      return base::string16(reinterpret_cast<const base::char16*>(u"Media Process"));
+#endif
     case content::PROCESS_TYPE_PLUGIN:
     case content::PROCESS_TYPE_PPAPI_PLUGIN:
       return l10n_util::GetStringFUTF16(IDS_TASK_MANAGER_PLUGIN_PREFIX,
diff --git a/chrome/browser/task_manager/child_process_resource_provider.cc b/chrome/browser/task_manager/child_process_resource_provider.cc
index 0054b4b..c5012a8 100644
--- a/chrome/browser/task_manager/child_process_resource_provider.cc
+++ b/chrome/browser/task_manager/child_process_resource_provider.cc
@@ -213,6 +213,11 @@ base::string16 ChildProcessResource::GetLocalizedTitle() const {
       return l10n_util::GetStringFUTF16(IDS_TASK_MANAGER_UTILITY_PREFIX, title);
     case content::PROCESS_TYPE_GPU:
       return l10n_util::GetStringUTF16(IDS_TASK_MANAGER_GPU_PREFIX);
+#if defined(USE_GSTREAMER)
+    // TODO: add localized resource
+    case content::PROCESS_TYPE_MEDIA:
+      return base::string16(reinterpret_cast<const base::char16*>(u"Media Process"));
+#endif
     case content::PROCESS_TYPE_PLUGIN:
     case content::PROCESS_TYPE_PPAPI_PLUGIN:
       return l10n_util::GetStringFUTF16(IDS_TASK_MANAGER_PLUGIN_PREFIX, title);
diff --git a/chrome/utility/extensions/extensions_handler.cc b/chrome/utility/extensions/extensions_handler.cc
index 942545e..ef3bbc6 100644
--- a/chrome/utility/extensions/extensions_handler.cc
+++ b/chrome/utility/extensions/extensions_handler.cc
@@ -105,11 +105,15 @@ bool ExtensionsHandler::OnMessageReceived(const IPC::Message& message) {
 void ExtensionsHandler::OnCheckMediaFile(
     int64 milliseconds_of_decoding,
     const IPC::PlatformFileForTransit& media_file) {
+#if !defined(MEDIA_DISABLE_FFMPEG)
   media::MediaFileChecker checker(
       IPC::PlatformFileForTransitToFile(media_file));
   const bool check_success = checker.Start(
       base::TimeDelta::FromMilliseconds(milliseconds_of_decoding));
   Send(new ChromeUtilityHostMsg_CheckMediaFile_Finished(check_success));
+#else
+  Send(new ChromeUtilityHostMsg_CheckMediaFile_Finished(false));
+#endif
   ReleaseProcessIfNeeded();
 }
 
diff --git a/chrome/utility/media_galleries/media_metadata_parser.cc b/chrome/utility/media_galleries/media_metadata_parser.cc
index a39324e..bc0ee41 100644
--- a/chrome/utility/media_galleries/media_metadata_parser.cc
+++ b/chrome/utility/media_galleries/media_metadata_parser.cc
@@ -56,6 +56,8 @@ void ParseAudioVideoMetadata(
     std::vector<AttachedImage>* attached_images) {
   DCHECK(source);
   DCHECK(metadata);
+
+#if !defined(MEDIA_DISABLE_FFMPEG)
   media::AudioVideoMetadataExtractor extractor;
 
   if (!extractor.Extract(source, get_attached_images))
@@ -108,6 +110,9 @@ void ParseAudioVideoMetadata(
                                       &attached_images->back().type);
     }
   }
+#else
+  return;
+#endif
 }
 
 void FinishParseAudioVideoMetadata(
